autowatch=1;
inlets=4;
outlets=4;



var sliders=8;
var zone_dim=[42,24];
var orientation="vertical";
var datamatrix = new JitterMatrix(1,"float32",256);
var outputmatrix = new JitterMatrix(1,"float32",sliders);

//Mangage every inlet and send the data to the corresponding function
function list(a,b)
{

    if (inlet == 0){coordinates(a,b);}
    else if (inlet == 1){zone_size(a,b);}
	else if (inlet == 2){set_sliders(a)}
    else if (inlet == 3){set_orientation(a)}

}





function zone_size(x,y){
zone_dim[0]=x;
zone_dim[1]=y;
}

function set_sliders(s){
	sliders=s;
	var value
	//outputmatrix.Dim=s;
	outputmatrix = new JitterMatrix(1,"float32",sliders);

	for(i=0;i<sliders;i++){
		value=datamatrix.getcell(i);

		outputmatrix.setcell1d(i,value);

	}


	refresh();
}

function set_orientation(o){
if(o){orientation="horizontal"}
else{orientation="vertical"}
}




function coordinates(x,y){
var index;
var value;
var scaler=0.1;//add a margin up and down

	if(orientation=="vertical"){
		index=Math.floor(x/zone_dim[0]*sliders);
		value=y/zone_dim[1];
		
		
	}
	else if (orientation=="horizontal"){
		index=Math.floor(y/zone_dim[1]*sliders);
		value=x/zone_dim[0];
		
	}
	value=value*(1+(2*scaler))-scaler;//rescale
	if(value<0){value=0;}
	if(value>1){value=1;}
	datamatrix.setcell1d(index,value);

if(index<sliders){
	outputmatrix.setcell1d(index,value);
	outlet(1,index,value);
}



refresh();			
//outlet(0,"jit_matrix",outputmatrix.name);
//post(index,value,"\n");
//post(y,"\n");
}


function refresh(){outlet(0,"jit_matrix",outputmatrix.name);}